clc
clear all
i=1;

global JD_capture JD_escape sma_orbit e_orbit i_orbit  
global ra_capture ra_escape dec_capture dec_escape mu
global C3_capture C3_escape a_hyp_c a_hyp_e 
global DV_ESCAPE  DV_CAPTURE deltav_ascesa deltav_discesa 
global mi_ritorno mu_arrivo  M_TOTAL mi_ascesa mp_ascesa mi_discesa mp_discesa mp_ritorno mp_arrivo mu_discesa 

 C3_capture=7.778521;               % Capture energy level
 C3_escape=9.591409;                 % Escape energy level

 ra_capture=19.4*pi/180;          % Right ascension capture Vinf [rad]
 ra_escape=-124.1*pi/180;          % Right ascension escape hyperbola and Vinf [rad]
 dec_capture=38.7*pi/180;         % Declination capture Vinf [rad]
 dec_escape=8.7*pi/180;          % Declination escape hyperbola and Vinf [rad] 
 i_orbit=170*pi/180;
 
 ra_capture=ra_capture+pi;       % Right ascension capture hyperbola [rad]
 dec_capture=-dec_capture;       % Declination capture hyperbola [rad]
 
 
 sma_orbit=20411;
 e_orbit=0.82;
 mu=42828;
 

 %% INVERSIONE DATI
%   C3_escape= 20.6;               % Capture energy level
%  C3_capture=57.6;                 % Escape energy level
%  ra_escape=138*pi/180;          % Right ascension capture hyperbola [rad]
%  ra_capture=31.6*pi/180;          % Right ascension escape hyperbola [rad]
%  dec_escape=5.9*pi/180;         % Declination capture hyperbola [rad]
%  dec_capture=8.9*pi/180;          % Declination escape hyperbola [rad] 
%  i_orbit=10*pi/180;
%  sma_orbit=19550;
%  e_orbit=0.8;
%  mu=42828;
%  
% alpha sono le direzioni della V_inf e non dell'asintoto.
 
 
 
% LB=[349.75 156.12 277.29 45.4]*pi/180;
% UB=[349.75 156.12 277.29 45.4]*pi/180;

LB=[0 0 0 0]*pi/180;
UB=[360 360 360 360]*pi/180;
 
%LB=[ 6.2677    2.9260    5.0219    0.9459];
%UB=[ 6.2677    2.9260    5.0219    0.9459];
%LB=[349.75 156.12 277.29 45.4]*pi/180;
%UB=[349.75 156.12 277.29 45.4]*pi/180;

% LB=[1.2467 2.9009 0 0];
%UB=[1.2467 2.9009 360 360];
options = optimoptions('ga','SelectionFcn',@selectiontournament,'EliteCount',10,...
        'CrossoverFraction',0.2,'PlotFcn',{@gaplotbestf,@gaplotmaxconstr},'Display',...
        'iter','InitialPopulationRange', [0;2*pi],'MigrationDirection', 'both' );

toll=1e-2;
diff=1;
Res_test=10;

%[optimal_parameters, DELTA_V_MIN, val,output,population,scores]=ga(@Ottimizzazione_Piano,4,[],[],[],[],LB,UB,[],options);
[optimal_parameters,DELTA_V_MIN, val,output,population,scores]=ga(@optim_outplane_conmasse_deltavmin,5,[],[],[],[],LB,UB,[],options);
opt_capture=optimal_parameters*180/pi;

% Results

LAN_capture(i)=opt_capture(1);
RAAN_capture(i)=opt_capture(2);
INJECTION_capture(i)=opt_capture(3);
INJECTION_escape(i)=opt_capture(4);
rp(i)=opt_capture(5);
DV_STOPOVER(i)=DELTA_V_MIN;


% Grafici_Perturbations_2(optimal_parameters(1), optimal_parameters(2),S_vettore, S_vettore_e, R_vettore, R_vettore_e,nodi_c, nodi_e,i,p_vector,p_escape)
% 
% %% CAPTURE 1
% if n_capture(2)>=0
% OMEGA_capture=acos((n_capture'*[1;0;0])/(norm(n_capture)));
% else
%     OMEGA_capture=2*pi-acos((n_capture'*[1;0;0])/(norm(n_capture)));
% end
% if p_vector(3)>=0
% OMEGHINO_capture=acos((n_capture'*p_vector)/(norm(n_capture)*norm(p_vector)));
% else
%     OMEGHINO_capture=2*pi-acos((n_capture'*p_vector)/(norm(n_capture)*norm(p_vector)));
% end
% i_cattura_1=acos([0 0 1]*W_h_capture/norm(W_h_capture));
% stampa_iperbole_cattura_1(a_h_capture,e_h_capture,OMEGHINO_capture,OMEGA_capture,i_cattura_1)
% 
% %% ESCAPE 1
% if n_escape(2)>=0
% OMEGA_escape=acos((n_escape'*[1;0;0])/(norm(n_escape)));
% else
%     OMEGA_escape=2*pi-acos((n_escape'*[1;0;0])/(norm(n_escape)));
% end
% if p_escape(3)>=0
% OMEGHINO_escape=acos((n_escape'*p_escape)/(norm(n_escape)*norm(p_escape)));
% else
%     OMEGHINO_escape=2*pi-acos((n_escape'*p_escape)/(norm(n_escape)*norm(p_escape)));
% end
% 
% i_escape_1=acos([0 0 1]*W_h_escape/norm(W_h_escape));
% stampa_iperbole_escape_1(a_h_escape,e_h_escape,OMEGHINO_escape,OMEGA_escape,i_escape_1)
% 
% 
% Grafici_Perturbations_2(optimal_parameters(1), optimal_parameters(2),S_vettore, S_vettore_e, R_vettore, R_vettore_e,nodi_c, nodi_e,2,p_vector,p_escape)
% hold on
% %% CATTURA 2
% if n_capture_2(2)>=0
% OMEGA_capture_2=acos((n_capture_2'*[1;0;0])/(norm(n_capture_2)));
% else
%     OMEGA_capture_2=2*pi-acos((n_capture_2'*[1;0;0])/(norm(n_capture_2)));
% end
% if p_vector_2(3)>=0
% OMEGHINO_capture_2=acos((n_capture_2'*p_vector_2)/(norm(n_capture_2)*norm(p_vector_2)));
% else
%     OMEGHINO_capture_2=2*pi-acos((n_capture_2'*p_vector_2)/(norm(n_capture_2)*norm(p_vector_2)));
% end
% i_cattura_2=acos([0 0 1]*W_h_capture_2/norm(W_h_capture_2));
% stampa_iperbole_cattura_2(a_h_capture,e_h_capture_2,OMEGHINO_capture_2,OMEGA_capture_2,i_cattura_2)
% 
% %% ESCAPE 2
% if n_escape_2(2)>=0
% OMEGA_escape_2=acos((n_escape_2'*[1;0;0])/(norm(n_escape_2)));
% else
%     OMEGA_escape_2=2*pi-acos((n_escape_2'*[1;0;0])/(norm(n_escape_2)));
% end
% if p_escape_2(3)>=0
% OMEGHINO_escape_2=acos((n_escape_2'*p_escape_2)/(norm(n_escape_2)*norm(p_escape_2)));
% else
%     OMEGHINO_escape_2=2*pi-acos((n_escape_2'*p_escape_2)/(norm(n_escape_2)*norm(p_escape_2)));
% end
% i_escape_2=acos([0 0 1]*W_h_escape_2/norm(W_h_escape_2));
% stampa_iperbole_escape_2(a_h_escape,e_h_escape_2,OMEGHINO_escape_2,OMEGA_escape_2,i_escape_2)


%% PARAMETRI ORBITALI CATTURA

H_po_c=cross(r_capture, V_capture);
i_po=acos(H_po_c(3)/norm(H_po_c));
n_po_c=cross([0;0;1],H_po_c)/norm(H_po_c);
if n_po_c(2)>=0
    RAAN_po_c=acos(n_po_c(1)/norm(n_po_c));
else
    RAAN_po_c=2*pi-acos(n_po_c(1)/norm(n_po_c));
end
e_po_c=cross(V_capture,H_po_c)/mu-r_capture/norm(r_capture);

if e_po_c(3)>=0
    AP_capt_c=acos((n_po_c'*e_po_c)/(norm(n_po_c)*norm(e_po_c)));
else
    AP_capt_c=2*pi-acos((n_po_c'*e_po_c)/(norm(n_po_c)*norm(e_po_c)));
end

%% PARAMETRI ORBITALI ESCAPE

H_po_e=cross(r_escape, V_escape);
i_po=acos(H_po_e(3)/norm(H_po_e));
n_po_e=cross([0;0;1],H_po_e)/norm(H_po_e);
if n_po_e(2)>=0
    RAAN_po_e=acos(n_po_e(1)/norm(n_po_e));
else
    RAAN_po_e=2*pi-acos(n_po_e(1)/norm(n_po_e));
end
e_po_e=cross(V_escape,H_po_e)/mu-r_escape/norm(r_escape);

if e_po_e(3)>=0
    AP_capt_e=acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
else
    AP_capt_e=2*pi-acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
end

%% PARAMETRI ORBITALI IPERBOLE CATTURA
H_hyp_c=cross(r_capture, V_h_capture);
i_hyp_c=acos(H_hyp_c(3)/norm(H_hyp_c));
n_hyp_c=cross([0;0;1],H_hyp_c)/norm(H_hyp_c);
if n_hyp_c(2)>=0
    RAAN_hyp_c=acos(n_hyp_c(1)/norm(n_hyp_c));
else
    RAAN_hyp_c=2*pi-acos(n_hyp_c(1)/norm(n_hyp_c));
end
e_hyp_c=cross(V_h_capture,H_hyp_c)/mu-r_capture/norm(r_capture);
if e_hyp_c(3)>=0
    AP_hyp_c=acos((n_hyp_c'*e_hyp_c)/(norm(n_hyp_c)*norm(e_hyp_c)));
else
    AP_hyp_c=2*pi-acos((n_hyp_c'*e_hyp_c)/(norm(n_hyp_c)*norm(e_hyp_c)));
end


%% PARAMETRI ORBITALI IPERBOLE FUGA
H_hyp_e=cross(r_escape, V_h_escape);
i_hyp_e=acos(H_hyp_e(3)/norm(H_hyp_e));
n_hyp_e=cross([0;0;1],H_hyp_e)/norm(H_hyp_e);
if n_hyp_e(2)>=0
    RAAN_hyp_e=acos(n_hyp_e(1)/norm(n_hyp_e));
else
    RAAN_hyp_e=2*pi-acos(n_hyp_e(1)/norm(n_hyp_e));
end
e_hyp_e=cross(V_h_escape,H_hyp_e)/mu-r_escape/norm(r_escape);
if e_hyp_e(3)>=0
    AP_hyp_e=acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
else
    AP_hyp_e=2*pi-acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
end

%% PARAMETRI ORBITALI SECONDA IPERBOLE CATTURA
H_hyp_c_2=cross(r_capture, V_h_capture_2);
i_hyp_c_2=acos(H_hyp_c_2(3)/norm(H_hyp_c_2));
n_hyp_c_2=cross([0;0;1],H_hyp_c_2)/norm(H_hyp_c_2);
if n_hyp_c_2(2)>=0
    RAAN_hyp_c_2=acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
else
    RAAN_hyp_c_2=2*pi-acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
end
e_hyp_c_2=cross(V_h_capture_2,H_hyp_c_2)/mu-r_capture/norm(r_capture);
if e_hyp_c_2(3)>=0
    AP_hyp_c_2=acos((n_hyp_c'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
else
    AP_hyp_c_2=2*pi-acos((n_hyp_c_2'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
end

%% PARAMETRI ORBITALI SECONDA IPERBOLE FUGA
H_hyp_e_2=cross(r_escape, V_h_escape_2);
i_hyp_e_2=acos(H_hyp_e_2(3)/norm(H_hyp_e_2));
n_hyp_e_2=cross([0;0;1],H_hyp_e_2)/norm(H_hyp_e_2);
if n_hyp_e_2(2)>=0
    RAAN_hyp_e_2=acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
else
    RAAN_hyp_e_2=2*pi-acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
end
e_hyp_e_2=cross(V_h_escape_2,H_hyp_e_2)/mu-r_escape/norm(r_escape);
if e_hyp_e_2(3)>=0
    AP_hyp_e_2=acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
else
    AP_hyp_e_2=2*pi-acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
end

%% PLOT
Grafici_Perturbations_2(V_escape,V_capture,V_h_escape,V_h_capture,optimal_parameters(1), optimal_parameters(2),S_vettore, S_vettore_e, R_vettore, R_vettore_e,nodi_c, nodi_e,i,p_vector,p_escape)

stampa_iperbole_cattura_1(a_h_capture,e_h_capture,AP_hyp_c,RAAN_hyp_c,i_hyp_c)
stampa_iperbole_escape_1(a_h_escape,e_h_escape,AP_hyp_e,RAAN_hyp_e,i_hyp_e)

%Grafici_Perturbations_2(optimal_parameters(1), optimal_parameters(2),S_vettore, S_vettore_e, R_vettore, R_vettore_e,nodi_c, nodi_e,2,p_vector,p_escape)
%hold on
%stampa_iperbole_cattura_1(a_h_capture,e_h_capture_2,-AP_hyp_c_2,-RAAN_hyp_c_2,i_hyp_c_2)
%stampa_iperbole_escape_1(a_h_escape,e_h_escape_2,-AP_hyp_e_2,-RAAN_hyp_e_2,i_hyp_e_2)