%% Funzione che calcola l'anomalia vera, r e v come vettori nel sistema perifocale per un dato punto identificato dal tempo t in una traiettoria definita da: a, e

function [E,ni_rad,r_perifocale,v_perifocale]= plot_orbita(a,e,t) 

mu = 42828; 
   
i = 1;

M = t*sqrt(mu/(a^3));   % stima iniziale dell'anomalia eccentrica (rad)
E(1) = M;
toll = 1e-6;            % tolleranza limite
ERR= 1e-6;              % errore commesso nel calcolo della soluzione

while ERR>=toll
     f(i) = E(i)-e*sin(E(i));
     df(i) = 1-e*cos(E(i));
     E(i+1) = E(i)+((M-f(i))/(df(i)));
     ERR = abs(M-f(i));
     deltaE(i) = abs(E(i+1)-E(i));
     i = i+1;
end

E_rad = E(end);
E = E_rad*180/pi;      % anomalia eccentrica (deg)

% controllo di eventuali multipli
if( E>360)
    m = E/360;
    E = (m-floor(m))*360;
    E_rad = E*pi/180;
end

% calcolo anomalia vera
ni = acos((cos(E_rad)-e)/(1-e*(cos(E_rad))));

% operazioni di controllo del valore di nu:
if (E_rad>pi && E_rad<2*pi)
    ni = (2*pi-ni)*180/pi;
end

if(E_rad<=pi && E_rad>=0)
     ni = ni*180/pi;
end

ni_rad=ni*pi/180;
% posizione e velocit? nel sistema perifocale
r = a*(1-e^2)/(1+e*cos(ni_rad));
h = sqrt(mu*a*(1-e^2));
r_perifocale = r*[cos(ni_rad), sin(ni_rad), 0];
v_perifocale = mu/h*[-sin(ni_rad), e+cos(ni_rad), 0];
end






